#pragma once

#include <RobotAPI/libraries/PriorKnowledge/core/PKDatasetFinder.h>

namespace armarx::priorknowledge::motions
{
    class MotionFinder : public core::PKDatasetFinder
    {

    public:
        using core::PKDatasetFinder::PKDatasetFinder;
        static const constexpr auto DEFAULT_DIR_TO_DATASETS = "motions";

        MotionFinder(const std::filesystem::path& relDir = DEFAULT_DIR_TO_DATASETS) :
            core::PKDatasetFinder(relDir)
        {
        }

        bool
        accept(const std::filesystem::path& idPath) const final
        {
            return std::filesystem::is_directory(idPath);
        }

        void
        registerPropertyDefinitions(armarx::PropertyDefinitionsPtr& defs,
                                    const std::string& prefix = "pk.finder.motions.") final
        {
            core::PKDatasetFinder::registerPropertyDefinitions(defs, prefix);
        }
    };

} // namespace armarx::priorknowledge::motions
