#pragma once

#include <SimoxUtility/color/Color.h>
#include <SimoxUtility/shapes/AxisAlignedBoundingBox.h>
#include <SimoxUtility/shapes/OrientedBox.h>

#include <RobotAPI/libraries/aron/common/forward_declarations.h>
#include <RobotAPI/libraries/aron/core/aron_conversions.h>

namespace armarx::aron::simox
{
    namespace arondto
    {
        using AxisAlignedBoundingBox = ::simox::arondto::AxisAlignedBoundingBox;
        using OrientedBox = ::simox::arondto::OrientedBox;
        using Color = ::simox::arondto::Color;
    } // namespace arondto

    void fromAron(const arondto::AxisAlignedBoundingBox& dto, ::simox::AxisAlignedBoundingBox& bo);
    void toAron(arondto::AxisAlignedBoundingBox& dto, const ::simox::AxisAlignedBoundingBox& bo);

    void fromAron(const arondto::OrientedBox& dto, ::simox::OrientedBoxf& bo);
    void toAron(arondto::OrientedBox& dto, const ::simox::OrientedBoxf& bo);

    void fromAron(const arondto::Color& dto, ::simox::Color& bo);
    void toAron(arondto::Color& dto, const ::simox::Color& bo);
} // namespace armarx::aron::simox

namespace armarx::aron
{
    using simox::fromAron;
    using simox::toAron;
} // namespace armarx::aron

namespace armarx
{
    using aron::simox::fromAron;
    using aron::simox::toAron;
} // namespace armarx

// Legacy support
namespace simox
{
    using ::armarx::aron::simox::fromAron;
    using ::armarx::aron::simox::toAron;
} // namespace simox
